#include <stdio.h>
#include <malloc.h>

int bgmtable[][4]={
	//t@Cʒu@kTCY@𓀃TCY@ǋLpϐ
	{0x29ec7bd, 0x2ea9, 0x3684 , 0x0},
	{0x29e9587, 0x3236, 0x699b , 0x17},
	{0x29ef7ab, 0x410b, 0x79c8 , 0x0},
	{0x29f38b6, 0x7811, 0x123e9, 0x0},
	{0x29fb0c7, 0x49c1, 0x93b5 , 0x0},

	{0x29ffa88, 0x468a, 0x7c16 , 0x12},
	{0x2a04112, 0x5ea6, 0xbfbc , 0x0},
	{0x2a09fb8, 0x3fb4, 0x8e62 , 0x0},
	{0x2a0df6c, 0x7b62, 0x16f17, 0x13},
	{0x2a15ace, 0x4b64, 0xc109 , 0x05},

	{0x2a1a632, 0x7289, 0xff58 , 0x0},
	{0x2a218bb, 0x4f59, 0xabac , 0x0},
	{0x2a26814, 0x3ead, 0x7db5 , 0x0},
	{0x2a2e389, 0x7aa8, 0x128a4, 0x0},
	{0x2a35e31, 0x679b, 0x1155b, 0x0},

	{0x2a2a6c1, 0x3cc8, 0x7e19 , 0x15},
	{0x2a439d9, 0x5921, 0xfd4b , 0x0},
	{0x2a492fa, 0xa021, 0x17e03, 0x0},
	{0x2a3c5cc, 0x2c06, 0x34ca , 0x0},
	{0x2a3f1d2, 0x4807, 0x9ea6 , 0x0},
	
	{0x2a5331b, 0x345a, 0x69b0 , 0x0},
};

char bgmfile[][14]={
	"th08_01.mid",
	"th08_02.mid",
	"th08_03.mid",
	"th08_04.mid",
	"th08_05.mid",
	"th08_06.mid",
	"th08_07.mid",
	"th08_08.mid",
	"th08_09.mid",
	"th08_10.mid",
	"th08_11.mid",
	"th08_12.mid",
	"th08_13.mid",
	"th08_14.mid",
	"th08_15.mid",
	"th08_16.mid",
	"th08_17.mid",
	"th08_18.mid",
	"th08_19.mid",
	"th08_20.mid",
	"th08_21.mid",
};

void decode1(char *, char *, int, int);
void decode2(char *, char *, int, int);
int bit(char **, int *, int);

int main(){
	int i;
	char *enc, *dec1, *dec2;
	FILE *datf, *bgmf;

	datf=fopen("th08.dat","rb");
	if(datf == NULL){
		printf("th08.dat not found.");
		return 0;
	}

	enc  = (char *)malloc(0x4ADE20 * 2);
	dec1 = (char *)malloc(0x4ADE20 * 2);
	dec2 = (char *)malloc(0x4ADE20 * 2);
	if(enc == NULL || dec1 == NULL || dec2 == NULL){
		printf("Can't allocate memory\n");
		return 0;
	}

	for(i=0; i<21; i++){
		printf("Create %s ... \n", bgmfile[i]);

		bgmf = fopen(bgmfile[i], "wb");
		if(bgmf == NULL){
			printf("Can't open file %s\n", bgmfile[i]);
			break;
		}
		fseek(datf, bgmtable[i][0], SEEK_SET);
		fread(enc, 1, bgmtable[i][1], datf);

		decode1(enc,  dec1, bgmtable[i][1], bgmtable[i][2]);
		decode2(dec1, dec2, bgmtable[i][2], bgmtable[i][3]);

		if(fwrite(dec2, 1, bgmtable[i][2]-0x04, bgmf) == 0){
			printf("Can't write file %s\n", bgmfile[i]);
			fclose(bgmf);
			break;
		}
		fclose(bgmf);
	}
	free(enc);
	free(dec1);
	free(dec2);
	fclose(datf);
	
	return 0;
}

//0x80Pʂ̕ёւAxorŕ
//g[X̓̕fobJŒǂĂ݂Ă
void decode2(char *p1, char *p2, int d_size, int key){

	int i;
	int cut = 0x80;
	int m_size = 0x2800;
	char xor = 0x35;
	char *pt;

	p1     += 0x04;
	d_size -= 0x04;

	key  += d_size & 0x01;
	d_size -= key;

	while(d_size > 0 && m_size > 0){
		if(d_size < cut)
			cut = d_size;
		
		pt = p2 + (cut - 1);
		for(i=0; i<(cut+1)/2; i++){
			*pt = *p1++ ^ xor;
			xor = (xor + 0x97) & 0xff;
			pt -= 2;
		}
		pt = p2 + (cut - 2);
		for(i=0; i<cut/2; i++){
			*pt = *p1++ ^ xor;
			xor = (xor + 0x97) & 0xff;
			pt -= 2;
		}

		d_size -= cut;
		p2     += cut;
		m_size -= cut;
	}

	d_size += key * 4;
	for(i=d_size; i>0; i--){
			*p2++ = *p1++;
	}
}

//ky@
void decode1(char *p1, char *p2, int d1, int d2)
{
	char *dic_p = p2 + 0x630041;
	char *e_p   = p2 + d2;
	char buf;

	int adr;
	int cnt = 1;
	int chk = 0x100;
	int i,j;

	while(p2 < e_p){

		if( bit(&p1, &chk, 1) ){
			buf = bit(&p1, &chk, 8);

			*p2++ = buf;
			*(dic_p + cnt) = buf;
			cnt = (cnt + 1) & 0x1fff;
		}
		else {

			adr = bit(&p1, &chk, 13);
			j   = bit(&p1, &chk, 4);

			for(i=0; i<=j+2; i++){
				buf = *(dic_p + adr);
				adr = (adr + 1) & 0x1fff;

				*p2++ = buf;
				*(dic_p + cnt) = buf;
				cnt = (cnt + 1) & 0x1fff;
			}
		}
	}
}

//rbgPʂ̎o
int bit(char **p1, int *chk, int turn)
{
	int i, result=0;

	for(i=0; i<turn; i++){
		result <<=1;

		*chk >>= 1;
		if(*chk == 0x00){
			*chk = 0x80;
			*p1 = *p1 + 1;
		}

		if(**p1 & *chk)
			result |= 0x01;
	}
	return result;
}
